// MainFrm.h : interface of the CMainFrame class
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_MAINFRM_H__9B31E3C8_4EF0_11D1_805B_0000C0E2E89B__INCLUDED_)
#define AFX_MAINFRM_H__9B31E3C8_4EF0_11D1_805B_0000C0E2E89B__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

#define NumSysColors    (sizeof(SysPalIndex)/sizeof(SysPalIndex[1]))
#define rgbBlack        RGB(0,0,0)
#define rgbWhite        RGB(255,255,255)

#define PALETTETIMER		100

/* These are the GetSysColor display element identifiers */
static int SysPalIndex[] = {
    COLOR_ACTIVEBORDER,
    COLOR_ACTIVECAPTION,
    COLOR_APPWORKSPACE,
    COLOR_BACKGROUND,
    COLOR_BTNFACE,
    COLOR_BTNSHADOW,
    COLOR_BTNTEXT,
    COLOR_CAPTIONTEXT,
    COLOR_GRAYTEXT,
    COLOR_HIGHLIGHT,
    COLOR_HIGHLIGHTTEXT,
    COLOR_INACTIVEBORDER,
    COLOR_INACTIVECAPTION,
    COLOR_MENU,
    COLOR_MENUTEXT,
    COLOR_SCROLLBAR,
    COLOR_WINDOW,
    COLOR_WINDOWFRAME,
    COLOR_WINDOWTEXT
    };


class CMainFrame : public CFrameWnd
{
public: // create from serialization only
	CMainFrame();
	DECLARE_DYNCREATE(CMainFrame)
			

protected:
	void InitMGL(void);
	MGLDC *LoadBitmapIntoMemDC(MGLDC *dc, const char *bitmapName);
	MGLDC *LoadJPEGIntoMemDC(MGLDC *dc, const char *jpegName);
	void LoadBitmapPalette(MGLDC *winDC,MGLDC *memDC);

	void GetMemoryBitmapDepth(MGLDC *dc,int *bits,pixel_format_t *pf);
	void CreateMGLDeviceContexts(HWND hwnd);
	void AppActivate(BOOL fActive);

	MGLDC		*winDC;
	MGLDC		*memDC;
	BOOL		haveTrueColor;
	BOOL		m_bStretch;
	BOOL		fAppActive;
	BOOL		includeStatic;
	BOOL		animatePalette;



public:
// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CMainFrame)
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CMainFrame();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

// Generated message map functions
protected:
	//{{AFX_MSG(CMainFrame)
	afx_msg void OnPaint();
	afx_msg void OnFileOpen();
	afx_msg void OnOptionsstretch();
	afx_msg void OnUpdateOptionsstretch(CCmdUI* pCmdUI);
	afx_msg void OnActivateApp(BOOL bActive, HTASK hTask);
	afx_msg BOOL OnQueryNewPalette();
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg void OnPaletteChanged(CWnd* pFocusWnd);
	afx_msg BOOL OnEraseBkgnd(CDC* pDC);
	afx_msg void OnOptionsIncludestatic();
	afx_msg void OnUpdateOptionsIncludestatic(CCmdUI* pCmdUI);
	afx_msg void OnOptionsAnimatepalette();
	afx_msg void OnUpdateOptionsAnimatepalette(CCmdUI* pCmdUI);
	afx_msg void OnTimer(UINT nIDEvent);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Developer Studio will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_MAINFRM_H__9B31E3C8_4EF0_11D1_805B_0000C0E2E89B__INCLUDED_)
